% ============================================================
% Macros: abbreviations for formulas
% ============================================================

% Abbreviation := Formula.

% ============================================================
% Lexicon: abstract constants
% ============================================================

0 :: a :: I^('$\\overline{a}$'@I).

1 :: s/a :: S^I^('$a$'@(S@I)).
2 :: (s/s)/a :: S1^S2^I^('$a$'@(S1@(S2@I))).
3 :: (s/a)/s :: S1^S2^I^('$a$'@(S1@(S2@I))).
4 :: ((s/s)/a)/s :: S1^S2^S3^I^('$a$'@(S1@(S2@(S3@I)))).

5 :: b :: I^('$\\overline{b}$'@I).

6 :: s/b :: S^I^('$b$'@(S@I)).
7 :: (s/s)/b :: S1^S2^I^('$b$'@(S1@(S2@I))).
8 :: (s/b)/s :: S1^S2^I^('$b$'@(S1@(S2@I))).
9 :: ((s/s)/b)/s :: S1^S2^S3^I^('$b$'@(S1@(S2@(S3@I)))).

10 :: (s/ <> '[ ]' a)\ s :: Q^I^((Q@(J^J))@('$\\overline{a}$'@I)).
15 :: (s/ <> '[ ]' b)\ s :: Q^I^((Q@(J^J))@('$\\overline{b}$'@I)).

% ============================================================
% Postulates
% ============================================================

% xright

'P1' # (A * B) * <> C ---> A * (B * <> C).
'P2' # (A * B) * <> C ---> (A * <> C) * B.

% ============================================================
% Examples
% ============================================================

