% ============================================================
% Macros: afkortingen voor formules die je vaak gebruikt
% ============================================================

% Afkorting := Formule.


% ============================================================
% Lexicon: abstract constants
% ============================================================

% a^n b^n c d^n e^n

% interpretation: strings

is :: s/a :: F^(F@'$c$').
as :: a/a :: F^X^I^('$a$'@((F@(J^('$b$'@(X@('$d$'@J)))))@('$e$'@I))).
es :: a :: J^J.

% interpretation: trees

it :: s/a :: F^(F@('$s_{1}$'@'$c$')).
at :: a/a :: F^X^(('$s_{3}$'@'$a$')@(F@((('$s_{3}$'@'$b$')@X)@'$d$'))@'$e$').
et :: a :: T^T.



% parenthesis shuffle language

%e :: sa :: X^X.

db :: s :: I^('$a$'@('$\\overline{a}$'@I)).
qp :: s :: I^('$b$'@('$\\overline{b}$'@I)).

dbs :: s/s :: S^I^('$a$'@('$\\overline{a}$'@(S@I))).
qps :: s/s :: S^I^('$b$'@('$\\overline{b}$'@(S@I))).

dsb :: s/s :: S^I^('$a$'@(S@('$\\overline{a}$'@I))).
qsp :: s/s :: S^I^('$b$'@(S@('$\\overline{b}$'@I))).

dsbs :: (s/s)/s :: S1^S2^I^('$a$'@(S1@('$\\overline{a}$'@(S2@I)))).
qsps :: (s/s)/s :: S1^S2^I^('$b$'@(S1@('$\\overline{b}$'@(S2@I)))).

aa :: sa/sa :: G^X^I^('$a$'@((G@X)@('$\\overline{a}$'@I))).
ba :: sa/sa :: G^X^I^('$b$'@((G@X)@('$\\overline{b}$'@I))).

aae :: sa :: X^I^('$a$'@(X@('$\\overline{a}$'@I))).
bae :: sa :: X^I^('$b$'@(X@('$\\overline{b}$'@I))).

aas :: (sa/s)/sa :: G^S^X^I^('$a$'@((G@X)@('$\\overline{a}$'@(S@I)))).
bas :: (sa/s)/sa :: G^S^X^I^('$b$'@((G@X)@('$\\overline{b}$'@(S@I)))).

ax :: s/sa :: F^I^((F@'$a$')@('$\\overline{a}$'@I)).
bx :: s/sa :: F^I^((F@'$b$')@('$\\overline{b}$'@I)).

% ============================================================
% Postulates
% ============================================================


% ============================================================
% Examples
% ============================================================

