% ============================================================
% Macros: afkortingen voor formules die je vaak gebruikt
% ============================================================

% Afkorting := Formule.

iv := np\s.
tv := iv/np.

% ============================================================
% Lexicon: je woordenboek
% ============================================================

% Woord :: Formule.
% Beperk je tot de volgende atomaire formules:
% s (zin), np (naam: "Alice"), n (zelfstandig naamwoord: "girl").

alice :: np.

bed :: n.
speech :: n.
result :: n.
key:: n.

the :: np/n.

slept :: iv.
found :: tv.
counts :: iv/pp.

there :: iv\iv.

on :: pp/np.

needs :: iv/((s/np)\s).

something :: (s/ <> '[ ]' np)\s.

in :: (iv\iv)/np.
during :: ( '[ ]' (iv\iv) )/np.

that :: (n\n)/(np\s) :: P^Q^X^((Q@X) /\ (P@X)). % girl that dreams
that :: (n\n)/(s/ <> '[ ]'np) :: P^Q^X^((Q@X) /\ (P@X)).
which :: (n\n)/(s/ <> '[ ]'np) :: P^Q^X^((Q@X) /\ (P@X)).


% ============================================================
% Postulaten
% ============================================================

% xright: gecontroleerde extractie uit rechtertakken

'P1' # (A * B) * <> C ---> A * (B * <> C).
'P2' # (A * B) * <> C ---> (A * <> C) * B.
	








